  // Ex1503.cpp
  #include <iostream>
  using namespace std;
  class myClass
  {
     public:
       myClass();
       ~myClass();
       void ShowMember();
       static int GetStatic();
     private:
       int itsMember;
       static int itsStatic;
  };
    
  myClass::myClass():
    itsMember(1)
  {
     itsStatic++;
  }
      
  myClass::~myClass()
  {
     itsStatic--;
     cout << "In destructor. ItsStatic: " << itsStatic << endl;
  }
       
  void myClass::ShowMember()
  {
     cout << "itsMember: " << itsMember << endl;
  }
        
  int myClass::itsStatic = 0;
         
  int myClass::GetStatic()
  {
     return itsStatic;
  }
          
  int main()
  {
     myClass obj1;
     obj1.ShowMember();
     cout << "Static: " << myClass::GetStatic() << endl;
           
     myClass obj2;
     obj2.ShowMember();
     cout << "Static: " << myClass::GetStatic() << endl;
          
     myClass obj3;
     obj3.ShowMember();
     cout << "Static: " << myClass::GetStatic() << endl;
     return 0;
  }        
