//Exercise 19.1
template <class Type>
class List  
{ 
  
  public:
     List():head(0),tail(0),theCount(0) { }
     virtual ~List();
  
     void insert( Type value );
     void append( Type value );
     int is_present( Type value ) const;
     int is_empty() const { return head == 0; }
     int count() const { return theCount; }
  
  private:
     class ListCell
     {
       public:
          ListCell(Type value, ListCell *cell = 0):val(value),next(cell){}
          Type val;
          ListCell *next;
     };
  
     ListCell *head;
     ListCell *tail;
     int theCount;
};
